:- multifile query_description/3.
:- multifile smell_/2.

query_description(unique_layer_association, smell,'Every package has to be assigned to exactly one layer.').
          
smell_(unique_layer_association,PackageID) :-
   	package_not_assigned_to_exactly_one_layer__(PackageID).
    
%package_not_assigned_to_any_layer, is true if the given package is assigned to exactly one layer
% +PackageID      
package_not_assigned_to_exactly_one_layer__(PackageID) :-
   internal_package(PackageID),
   % using findall until a better idea is found, this works but is not elegant
   findall(Layer, cached_package_layer_assignment(PackageID,Layer), ListOfLayers),
   length(ListOfLayers,Count),
   not(Count=1).
   	  
   

