:- module( cultivate_basic_relationmetrics, [
			  relation_metric/5,
			  relation_metric/4
		  ]).
		  
:- dynamic  cached_relation_metric/4.

/* Relation metrics
   relation_metric(+MetricName, -FromID, -ToID, -MetricValue, -RangeAndThreshold) /5 
   relation_metric(+MetricName, -FromID, -ToID, -MetricValue)                     /4
*/
relation_metric(MetricName, FromID, ToID, MetricValue, RangeAndThreshold) :-
    ground(FromID),
    ground(ToID),
    cached_relation_metric(MetricName, FromID, ToID, MetricValue),
    !,
    metric_attributes(MetricName, RangeAndThreshold).
    
relation_metric(MetricName, FromID, ToID, MetricValue, RangeAndThreshold) :-
    not(ground(FromID)),
    not(ground(ToID)),
    cached_relation_metric(MetricName, FromID, ToID, MetricValue),
    metric_attributes(MetricName, RangeAndThreshold).    
    
relation_metric(MetricName, FromID, ToID, MetricValue, RangeAndThreshold) :-
    relation_metric_(MetricName, FromID, ToID, MetricValue),
    assert(cached_relation_metric(MetricName, FromID, ToID, MetricValue)),
    metric_attributes(MetricName, RangeAndThreshold).


relation_metric(MetricName, FromID, ToID, MetricValue) :-
	relation_metric(MetricName, FromID, ToID, MetricValue, _).
	
	