/**
* type_term_nqn(?TypeTerm, ?TypeName)
*
* Maps TypeTerm (eg. type(basic, int, 1)) and (unqualified) type name (eg. int[]).
*/
%basic type
type_term_nqn(type(basic, TypeID, 0), TypeName) :-
	nonvar(TypeID),
	TypeName == TypeID.

%class type
type_term_nqn(type(class, TypeID, 0), TypeName) :-
    classT(TypeID, _, TypeName, _).
    
%(basic) array type
type_term_nqn(type(basic, TypeID, Dim), TypeName) :-
    array_name(TypeID, Dim, TypeName).

%(class) array type
type_term_nqn(type(class, TypeID, Dim), TypeName) :-
    classT(TypeID, _, ClassName, _),
    array_name(ClassName, Dim, TypeName).

