/**
* full_qualified_name_javaelement(+Id,-Fqn)
* succeeds iff Arg2 is the full qualified name of Id Arg1
*/
full_qualified_name_javaelement(Id,Fqn) :-
  	packageT(Id,Fqn),
  	!.
full_qualified_name_javaelement(Id,Fqn4) :-
    anonymous_class(Id),
	classT(Id,Parent,_,_),
	newClassT(Parent,_,Enclosing,_,_,InstantiatedClass,_,_),
	ast_ancestor(Enclosing,EnclosingType),
	classT(EnclosingType,_,_,_),
	full_qualified_name_javaelement(EnclosingType,EnclFqn),
	full_qualified_name_javaelement(InstantiatedClass,Fqn),
	concat(EnclFqn, '$(',Fqn2),
	concat(Fqn2,Fqn,Fqn3),
	concat(Fqn3,')',Fqn4),
	!.
	
full_qualified_name_javaelement(Id,Fqn) :-
    not(anonymous_class(Id)),
  	fullQualifiedName__(Id,Fqn),
  	!.

full_qualified_name_javaelement(Id,Fqn4) :-
    methodDef(Id,EnclAnClass,_,_,_,_,_),
    anonymous_class(EnclAnClass),
    full_qualified_name_javaelement(EnclAnClass,Fqn4),
    !.
  
full_qualified_name_javaelement(Id,Fqn) :-
  	(
  	  methodT(Id,ClassId,Name,Parameters,_,_,_);
  	  (constructorT(Id, ClassId, Parameters, _, _), Name = '<init>')
  	),
  	not(anonymous_class(ClassId)),
  	fullQualifiedName__(ClassId,ClassFQN),
  	concat(ClassFQN,'.',ClassFQN2),  
  	concat(ClassFQN2,Name,Fqn3),
  	concat(Fqn3,'(',Fqn4),
  	parameter_types(Parameters,ListOfTypes),
	concat_atom(ListOfTypes,',',AtomOfParameterTypes), %concat the parameter type list by commata into an atom  	
  	concat(Fqn4,AtomOfParameterTypes,Fqn5),
  	concat(Fqn5,')',Fqn),
  	!.
  	
full_qualified_name_javaelement(Id,Fqn) :-
   fieldT(Id,ClassId,_,Name,_),
   not(anonymous_class(ClassId)),
   fullQualifiedName__(ClassId,ClassFQN),
   concat(ClassFQN,'.',ClassFQN2),
   concat(ClassFQN2,Name,Fqn),
   !.
   
full_qualified_name_javaelement(Id,Fqn) :-
  	nopT(Id,_,MethodId),
  	full_qualified_name_javaelement(MethodId,Fqn),
  	!.  
 	
/**
* parent_full_qualified_name_javaelement(+Id, -Fqn)
* see full_qualified_name_javaelement/2. if no fqn was found, the parent elements name is used.
*/
parent_full_qualified_name_javaelement(Id, Fqn) :-
    enclosing(Id, ParentId),
    
    full_qualified_name_javaelement(ParentId, Fqn),
    !.

fullQualifiedName__(ID,Name) :- fullQualifiedName(ID,UName),flatten_unqualified_type(UName,Name).



			
