/**
* class_modifier(+ClassID, ?Modifier) 
*
* gets the modifier (static, final, strictfp, abstract) of the class, 
* or checks if the given modifier is correct for the given class.
*/
class_modifier(ClassID, static) :- 
    ground(ClassID),
    classT(ClassID, _, _, _),
	modifierT(ClassID, static).

class_modifier(ClassID, final) :- 
    ground(ClassID),
    classT(ClassID, _, _, _),
	modifierT(ClassID, final).

class_modifier(ClassID, strictfp) :- 
    ground(ClassID),
    classT(ClassID, _, _, _),
	modifierT(ClassID, strictfp).

class_modifier(ClassID, abstract) :- 
    ground(ClassID),
    classT(ClassID, _, _, _),
	modifierT(ClassID, abstract).