%%% taxonomy(?Type)
%% succeeds if Type is an empty interface extending another interface
%%
%% An empty interface which extends a single interface is called a Taxonomy,
%% since it is included, in the subtyping sense, in its parent, but
%% otherwise identical to it.
taxonomy(Interface):-
   classT(Interface,_,_,_),
   is_interface(Interface),
   not(type_contains_method(Interface, _)),
   implementsT(Interface,_). %Bug in JT2.8!! there is no extendsT fact for interface extension but an implementsT

%% There are also classes which are Taxonomy. Such a class must similarly
%% be empty, i.e., add no fields nor methods to its parent. Since
%% constructors are not inherited, an empty class may contain constructors.
%% A Taxonomy class may not implement any interfaces.
taxonomy(Type):-
   classT(Type,_,_,_),
   not(is_interface(Type)),
   not(type_contains_method(Type, _)),
   not(type_contains_field(Type,_)),
   not(implementsT(Type,_)),	  
   extendsT(Type,_).
    
