:- module('cultivate_concepts_nano',[ 
										nano_pattern/2 
									 ]).

%%  micropattern(+Name,?ID)
nano_pattern(Name,MethodID):-
    ground(Name),
    Predicate =.. [Name, MethodID],
    call(Predicate).
%% --> defined_in_module(micropatterns,A)  liefer alle prdikate definiert im micropatterns modul

nano_pattern(Name,MethodID):-
    not(ground(Name)),
    declared_in_module(cultivate_concepts_nano,B),
    cultivate_concepts_nano:current_predicate(Name,B),
    term_variables(B,[MethodID]),
    call(cultivate_concepts_nano:B).
    

% recursive call to itself
recursive(Method):-
    methodT(Method,_,_,_,_,_,_),
    once(( 
		    ri_callT_encl(Method,Call),
		    callT(Call,_,_,_,_,_,Method)
		)).
% does not issue any method calls
leaf(Method):-
	methodT(Method,_,_,_,_,_,_),
    not(ri_callT_encl(Method,_)).	
    
% returns void
returns_void(Method):-
    methodT(Method,_,_,_,type(basic,void,0),_,_).
    
    
% no parameters
no_params(Method):-
    methodT(Method,_,_,[],_,_,_).
    
% field reader
field_reader(Method):-
    methodT(Method,Class,_,_,_,_,_),
    once((
    		ri_getFieldT_encl(Method,GetField),
    		getFieldT(GetField,_,_,_,_,Field),
    		fieldT(Field,Class,_,_,_)
    	)).

% field writer
field_writer(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_assignT_encl(Method,_)).
    
% contains loop: do,while,for,for each
contains_loop(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_foreachT_encl(Method,_)).
    
contains_loop(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_forT_encl(Method,_)).

contains_loop(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_whileT_encl(Method,_)).

contains_loop(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_doWhileT_encl(Method,_)).

% creates object new array or object
creates_object(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_newClassT_encl(Method,_)).
creates_object(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_newArrayT_encl(Method,_)).	
	
% throws exception
throws_exception(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_throwT_encl(Method,_)).

% type manipulator (instanceof, checkcast)
type_manipulator(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_typeCastT_encl(Method, _)).
    
type_manipulator(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once(ri_typeTestT_encl(Method,_)).
    
%local assignment 
local_assignment(Method):-
    methodT(Method,_,_,_,_,_,_),	
    once( (
		    ri_assignT_encl(Method,Assign),
		    assignT(Assign,_,_,Lhs,_),
		    identT(Lhs,_,_,_,Ref),
		    localT(Ref,_,Method,_,_,_) 
		 ) ).
    
%same name call		
same_name_call(Method):-
    methodT(Method,_,Name,_,_,_,_),
    once(( 
		    ri_callT_encl(Method,Call),
		    callT(Call,_,_,_,_,_,Ref),
		    methodT(Ref,_,Name,_,_,_,_)
		)).
		
% null test
null_test(Method):-
    methodT(Method,_,_,_,_,_,_),
    once(( 
			ri_operationT_encl(Method,Cond),
			operationT(Cond,_,_,[A,B],'==',_),
			(identT(A,_,_,null,null) ; identT(B,_,_,null,null))

		)).		