% term_edge/3
% (+Context,_?Term,?DependingTerm)
% True iff Term and Depending Term are from the same StatementId in Context
term_edge(Context,Term,DependingTerm):-
    cached_occurrences_of_term_in_context(Context,Term,_),
    term_edge__(Context,Term,DependingTerm).
    
% term_edge__/3
% (+Context,+Term,?DependingTerm)
% True iff Term and Depending Term are from the same StatementId in Context
% Is undirectional, returns (a,b) and (b,a) 
term_edge__(Context,Term,DependingTerm):-
    context_has_term(Context,Term,Id),
    context_has_term(Context,DependingTerm,Id),
    not(Term == DependingTerm).